searchData={"items":[{"type":"module","title":"DiscoLog","doc":"Elixir-based built-in error tracking solution.","ref":"DiscoLog.html"},{"type":"function","title":"DiscoLog.log_error/3","doc":"","ref":"DiscoLog.html#log_error/3"},{"type":"function","title":"DiscoLog.log_info/3","doc":"","ref":"DiscoLog.html#log_info/3"},{"type":"function","title":"DiscoLog.report/4","doc":"","ref":"DiscoLog.html#report/4"},{"type":"function","title":"DiscoLog.send_error/2","doc":"","ref":"DiscoLog.html#send_error/2"},{"type":"module","title":"DiscoLog.Config","doc":"DiscoLog configuration","ref":"DiscoLog.Config.html"},{"type":"module","title":"Configuration Schema - DiscoLog.Config","doc":"* `:otp_app` (`t:atom/0`) - Required. Name of your application\n\n* `:token` (`t:String.t/0`) - Required. Your Discord bot token\n\n* `:guild_id` (`t:String.t/0`) - Required. Discord Server ID\n\n* `:category_id` (`t:String.t/0`) - Required. Category (Channel) ID\n\n* `:occurrences_channel_id` (`t:String.t/0`) - Required. Forum channel ID for error occurrences\n\n* `:info_channel_id` (`t:String.t/0`) - Required. Text channel ID for info-level logs\n\n* `:error_channel_id` (`t:String.t/0`) - Required. Text channel ID for logs higher than info-level logs\n\n* `:enable` (`t:boolean/0`) - Automatically start DiscoLog? The default value is `true`.\n\n* `:enable_logger` (`t:boolean/0`) - Automatically attach logger handler? The default value is `true`.\n\n* `:enable_discord_log` (`t:boolean/0`) - Log requests to Discord API? The default value is `false`.\n\n* `:enable_presence` (`t:boolean/0`) - Show DiscoLog bot status as Online? The default value is `false`.\n\n* `:instrument_oban` (`t:boolean/0`) - Automatically instrument Oban? The default value is `true`.\n\n* `:instrument_phoenix` (`t:boolean/0`) - Automatically instrument Phoenix? The default value is `true`.\n\n* `:instrument_tesla` (`t:boolean/0`) - Automatically instrument Tesla? The default value is `true`.\n\n* `:metadata` (list of `t:atom/0`) - List of Logger metadata keys to propagate with the message The default value is `[]`.\n\n* `:excluded_domains` (list of `t:atom/0`) - Logs with domains from this list will be ignored The default value is `[:cowboy, :bandit]`.\n\n* `:discord_client_module` (`t:atom/0`) - Discord client to use The default value is `DiscoLog.Discord.API.Client`.\n\n* `:supervisor_name` (`t:atom/0`) - Name of the supervisor process running DiscoLog The default value is `DiscoLog`.\n\n* `:presence_status` (`t:String.t/0`) - A message to display as the bot's status when presence is enabled The default value is `\"🪩 Disco Logging\"`.\n\n* `:enable_go_to_repo` (`t:boolean/0`) - Enable go_to_repo feature? The default value is `false`.\n\n* `:go_to_repo_top_modules` (list of `t:String.t/0`) - List of top-level modules that are not part of the application spec but code belongs to the app The default value is `[]`.\n\n* `:repo_url` (`t:String.t/0`) - URL to the git repository viewer The default value is `\"\"`.\n\n* `:git_sha` (`t:String.t/0`) - The git SHA of the running app The default value is `\"\"`.","ref":"DiscoLog.Config.html#module-configuration-schema"},{"type":"type","title":"DiscoLog.Config.config/0","doc":"","ref":"DiscoLog.Config.html#t:config/0"},{"type":"function","title":"DiscoLog.Config.read!/0","doc":"Reads and validates config from global application configuration","ref":"DiscoLog.Config.html#read!/0"},{"type":"function","title":"DiscoLog.Config.validate/1","doc":"Validates configuration against the schema","ref":"DiscoLog.Config.html#validate/1"},{"type":"function","title":"DiscoLog.Config.validate!/1","doc":"See `validate/1`","ref":"DiscoLog.Config.html#validate!/1"},{"type":"module","title":"DiscoLog.Context","doc":"Add context to logs and errors using the Logger metadata.","ref":"DiscoLog.Context.html"},{"type":"function","title":"DiscoLog.Context.get/0","doc":"Obtain the context of the current process.","ref":"DiscoLog.Context.html#get/0"},{"type":"function","title":"DiscoLog.Context.set/2","doc":"","ref":"DiscoLog.Context.html#set/2"},{"type":"module","title":"DiscoLog.Dedupe","doc":"Dedupe module to prevent reporting error multiple times.\n\nOriginal implementation from Sentry Elixir\nhttps://github.com/getsentry/sentry-elixir/blob/69ac8d0e3f33ff36ab1092bbd346fdb99cf9d061/lib/sentry/dedupe.ex","ref":"DiscoLog.Dedupe.html"},{"type":"function","title":"DiscoLog.Dedupe.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DiscoLog.Dedupe.html#child_spec/1"},{"type":"function","title":"DiscoLog.Dedupe.insert/2","doc":"","ref":"DiscoLog.Dedupe.html#insert/2"},{"type":"function","title":"DiscoLog.Dedupe.start_link/1","doc":"","ref":"DiscoLog.Dedupe.html#start_link/1"},{"type":"behaviour","title":"DiscoLog.Discord.API","doc":"A module for working with Discord REST API.\nhttps://discord.com/developers/docs/reference\n\nThis module is also a behavior. The default implementation uses the `Req` HTTP client. \nIf you want to use a different client, you'll need to implement the behavior and \nput it under the `discord_client_module` configuration option.","ref":"DiscoLog.Discord.API.html"},{"type":"type","title":"DiscoLog.Discord.API.client/0","doc":"The client can be any term. It is passed as a first argument to `c:request/4`. For example, the \ndefault `DiscoLog.Discord.API.Client` client uses `Req.Request.t()` as a client.","ref":"DiscoLog.Discord.API.html#t:client/0"},{"type":"callback","title":"DiscoLog.Discord.API.client/1","doc":"","ref":"DiscoLog.Discord.API.html#c:client/1"},{"type":"function","title":"DiscoLog.Discord.API.create_channel/3","doc":"","ref":"DiscoLog.Discord.API.html#create_channel/3"},{"type":"function","title":"DiscoLog.Discord.API.delete_channel/2","doc":"","ref":"DiscoLog.Discord.API.html#delete_channel/2"},{"type":"function","title":"DiscoLog.Discord.API.delete_message/3","doc":"","ref":"DiscoLog.Discord.API.html#delete_message/3"},{"type":"function","title":"DiscoLog.Discord.API.delete_thread/2","doc":"","ref":"DiscoLog.Discord.API.html#delete_thread/2"},{"type":"function","title":"DiscoLog.Discord.API.get_channel/2","doc":"","ref":"DiscoLog.Discord.API.html#get_channel/2"},{"type":"function","title":"DiscoLog.Discord.API.get_channel_messages/2","doc":"","ref":"DiscoLog.Discord.API.html#get_channel_messages/2"},{"type":"function","title":"DiscoLog.Discord.API.get_gateway/1","doc":"","ref":"DiscoLog.Discord.API.html#get_gateway/1"},{"type":"function","title":"DiscoLog.Discord.API.list_active_threads/2","doc":"","ref":"DiscoLog.Discord.API.html#list_active_threads/2"},{"type":"function","title":"DiscoLog.Discord.API.list_channels/2","doc":"","ref":"DiscoLog.Discord.API.html#list_channels/2"},{"type":"function","title":"DiscoLog.Discord.API.post_message/3","doc":"","ref":"DiscoLog.Discord.API.html#post_message/3"},{"type":"function","title":"DiscoLog.Discord.API.post_thread/3","doc":"","ref":"DiscoLog.Discord.API.html#post_thread/3"},{"type":"callback","title":"DiscoLog.Discord.API.request/4","doc":"","ref":"DiscoLog.Discord.API.html#c:request/4"},{"type":"type","title":"DiscoLog.Discord.API.response/0","doc":"","ref":"DiscoLog.Discord.API.html#t:response/0"},{"type":"module","title":"DiscoLog.Discord.API.Client","doc":"Default `DiscoLog.Discord.API` implementation.","ref":"DiscoLog.Discord.API.Client.html"},{"type":"module","title":"DiscoLog.Encoder","doc":"Provide a safe encoding for map message which can containing any kind of\nElixir values and need to be safely encoded to JSON.","ref":"DiscoLog.Encoder.html"},{"type":"function","title":"DiscoLog.Encoder.encode!/2","doc":"","ref":"DiscoLog.Encoder.html#encode!/2"},{"type":"module","title":"DiscoLog.Error","doc":"Struct for error or exception.","ref":"DiscoLog.Error.html"},{"type":"function","title":"DiscoLog.Error.hash/1","doc":"Used to compare errors for deduplication original implementation from Sentry Elixir\nhttps://github.com/getsentry/sentry-elixir/blob/69ac8d0e3f33ff36ab1092bbd346fdb99cf9d061/lib/sentry/event.ex#L613","ref":"DiscoLog.Error.html#hash/1"},{"type":"function","title":"DiscoLog.Error.new/4","doc":"","ref":"DiscoLog.Error.html#new/4"},{"type":"type","title":"DiscoLog.Error.t/0","doc":"","ref":"DiscoLog.Error.html#t:t/0"},{"type":"module","title":"DiscoLog.Integrations.Oban","doc":"Integration with Oban.","ref":"DiscoLog.Integrations.Oban.html"},{"type":"module","title":"How to use it - DiscoLog.Integrations.Oban","doc":"It is a plug and play integration: as long as you have Oban installed the\nerror will be reported.","ref":"DiscoLog.Integrations.Oban.html#module-how-to-use-it"},{"type":"module","title":"How it works - DiscoLog.Integrations.Oban","doc":"It works using Oban's Telemetry events, so you don't need to modify anything\non your application.","ref":"DiscoLog.Integrations.Oban.html#module-how-it-works"},{"type":"module","title":"Default context - DiscoLog.Integrations.Oban","doc":"By default we store some context for you on errors generated in an Oban\nprocess:\n\n* `job.id`: the unique ID of the job.\n\n* `job.worker`: the name of the worker module.\n\n* `job.queue`: the name of the queue in which the job was inserted.\n\n* `job.args`: the arguments of the job being executed.\n\n* `job.priority`: the priority of the job.\n\n* `job.attempt`: the number of attempts performed for the job.","ref":"DiscoLog.Integrations.Oban.html#module-default-context"},{"type":"function","title":"DiscoLog.Integrations.Oban.handle_event/4","doc":"","ref":"DiscoLog.Integrations.Oban.html#handle_event/4"},{"type":"module","title":"DiscoLog.Integrations.Phoenix","doc":"Integration with Phoenix applications.","ref":"DiscoLog.Integrations.Phoenix.html"},{"type":"module","title":"How to use it - DiscoLog.Integrations.Phoenix","doc":"It is a plug and play integration: as long as you have Phoenix installed the\nDiscoLog will receive and store the errors as they are reported.\n\nIt also collects the exceptions that raise on your LiveView modules.","ref":"DiscoLog.Integrations.Phoenix.html#module-how-to-use-it"},{"type":"module","title":"How it works - DiscoLog.Integrations.Phoenix","doc":"It works using Phoenix's Telemetry events, so you don't need to modify\nanything on your application.","ref":"DiscoLog.Integrations.Phoenix.html#module-how-it-works"},{"type":"module","title":"Errors on the Endpoint - DiscoLog.Integrations.Phoenix","doc":"This integration only catches errors that raise after the requests hits your\nRouter. That means that an exception on a plug defined on your Endpoint will\nnot be reported.\n\nIf you want to also catch those errors, we recommend you to set up the\n`ErrorTracker.Integrations.Plug` integration too.","ref":"DiscoLog.Integrations.Phoenix.html#module-errors-on-the-endpoint"},{"type":"module","title":"Default context - DiscoLog.Integrations.Phoenix","doc":"For errors that are reported when executing regular HTTP requests (the ones\nthat go to Controllers), the context added by default is the same that you\ncan find on the `ErrorTracker.Integrations.Plug` integration.\n\nAs for exceptions generated in LiveView processes, we collect some special\ninformation on the context:\n\n* `live_view.view`: the LiveView module itself,\n\n* `live_view.uri`: last URI that loaded the LiveView (available when the\n`handle_params` function is invoked).\n\n* `live_view.params`: the params received by the LiveView (available when the\n`handle_params` function is invoked).\n\n* `live_view.event`: last event received by the LiveView (available when the\n`handle_event` function is invoked).\n\n* `live_view.event_params`: last event params received by the LiveView\n(available when the `handle_event` function is invoked).","ref":"DiscoLog.Integrations.Phoenix.html#module-default-context"},{"type":"module","title":"DiscoLog.Integrations.Plug","doc":"Integration with Plug applications.","ref":"DiscoLog.Integrations.Plug.html"},{"type":"module","title":"How to use it - DiscoLog.Integrations.Plug","doc":"","ref":"DiscoLog.Integrations.Plug.html#module-how-to-use-it"},{"type":"module","title":"Plug applications - DiscoLog.Integrations.Plug","doc":"The way to use this integration is by adding it to either your `Plug.Builder`\nor `Plug.Router`:\n\n```elixir\ndefmodule MyApp.Router do\n  use Plug.Router\n  use DiscoLog.Integrations.Plug\n\n  ...\nend\n```","ref":"DiscoLog.Integrations.Plug.html#module-plug-applications"},{"type":"module","title":"Phoenix applications - DiscoLog.Integrations.Plug","doc":"There is a particular use case which can be useful when running a Phoenix\nweb application.\n\nIf you want to record exceptions that may occur in your application's endpoint\nbefore reaching your router (for example, in any plug like the ones decoding\ncookies of body contents) you may want to add this integration too:\n\n```elixir\ndefmodule MyApp.Endpoint do\n  use Phoenix.Endpoint\n  use DiscoLog.Integrations.Plug\n\n  ...\nend\n```","ref":"DiscoLog.Integrations.Plug.html#module-phoenix-applications"},{"type":"module","title":"Default context - DiscoLog.Integrations.Plug","doc":"By default we store some context for you on errors generated during a Plug\nrequest:\n\n* `request.host`: the `conn.host` value.\n\n* `request.ip`: the IP address that initiated the request. It includes parsing\nproxy headers\n\n* `request.method`: the HTTP method of the request.\n\n* `request.path`: the path of the request.\n\n* `request.query`: the query string of the request.\n\n* `request.params`: parsed params of the request (only available if they have\nbeen fetched and parsed as part of the Plug pipeline).\n\n* `request.headers`: headers received on the request. All headers are included\nby default except for the `Cookie` ones, as they may include large and\nsensitive content like sessions.","ref":"DiscoLog.Integrations.Plug.html#module-default-context"},{"type":"module","title":"DiscoLog.Integrations.Tesla","doc":"Integration with Tesla","ref":"DiscoLog.Integrations.Tesla.html"},{"type":"module","title":"How to use it - DiscoLog.Integrations.Tesla","doc":"Your tesla client must be configured to use the Tesla.Middleware.Telemetry","ref":"DiscoLog.Integrations.Tesla.html#module-how-to-use-it"},{"type":"module","title":"How it works - DiscoLog.Integrations.Tesla","doc":"It works using Tesla's Telemetry events","ref":"DiscoLog.Integrations.Tesla.html#module-how-it-works"},{"type":"module","title":"Default context - DiscoLog.Integrations.Tesla","doc":"The Tesla.Env struct is converted to a map and passed as context to the error report.\n\nread more on https://hexdocs.pm/tesla/Tesla.Middleware.Telemetry.html#module-telemetry-events","ref":"DiscoLog.Integrations.Tesla.html#module-default-context"},{"type":"function","title":"DiscoLog.Integrations.Tesla.handle_event/4","doc":"","ref":"DiscoLog.Integrations.Tesla.html#handle_event/4"},{"type":"module","title":"DiscoLog.LoggerHandler","doc":"A logger handler [`:logger` handler](https://www.erlang.org/doc/apps/kernel/logger_chapter.html#handlers)\n\nOriginal source: https://github.com/getsentry/sentry-elixir/blob/69ac8d0e3f33ff36ab1092bbd346fdb99cf9d061/lib/sentry/logger_handler.ex","ref":"DiscoLog.LoggerHandler.html"},{"type":"module","title":"DiscoLog.Presence","doc":"A GenServer responsible for keeping the bot Online","ref":"DiscoLog.Presence.html"},{"type":"function","title":"DiscoLog.Presence.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DiscoLog.Presence.html#child_spec/1"},{"type":"function","title":"DiscoLog.Presence.start_link/1","doc":"","ref":"DiscoLog.Presence.html#start_link/1"},{"type":"module","title":"DiscoLog.Stacktrace","doc":"A struct that contains the information about the execution stack for a given\noccurrence of an exception.","ref":"DiscoLog.Stacktrace.html"},{"type":"function","title":"DiscoLog.Stacktrace.app_source/3","doc":"Source of the error stack trace if it belongs to the given application.","ref":"DiscoLog.Stacktrace.html#app_source/3"},{"type":"function","title":"DiscoLog.Stacktrace.new/1","doc":"","ref":"DiscoLog.Stacktrace.html#new/1"},{"type":"function","title":"DiscoLog.Stacktrace.source/2","doc":"Source of the error stack trace.\n\nThe first line matching the client application. If no line belongs to the current\napplication, just the first line.","ref":"DiscoLog.Stacktrace.html#source/2"},{"type":"type","title":"DiscoLog.Stacktrace.t/0","doc":"","ref":"DiscoLog.Stacktrace.html#t:t/0"},{"type":"module","title":"DiscoLog.Storage","doc":"A GenServer to store the mapping of fingerprint to Discord Thread ID.","ref":"DiscoLog.Storage.html"},{"type":"function","title":"DiscoLog.Storage.add_thread_id/3","doc":"Add a new fingerprint -> thread_id mapping","ref":"DiscoLog.Storage.html#add_thread_id/3"},{"type":"function","title":"DiscoLog.Storage.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DiscoLog.Storage.html#child_spec/1"},{"type":"function","title":"DiscoLog.Storage.get_tags/1","doc":"Retrieve the tag id for a given tag","ref":"DiscoLog.Storage.html#get_tags/1"},{"type":"function","title":"DiscoLog.Storage.get_thread_id/2","doc":"Retrieve the thread_id for a given fingerprint","ref":"DiscoLog.Storage.html#get_thread_id/2"},{"type":"function","title":"DiscoLog.Storage.start_link/1","doc":"Start the Storage","ref":"DiscoLog.Storage.html#start_link/1"},{"type":"module","title":"DiscoLog.Supervisor","doc":"Supervisor that manages all processes required for logging. By default,\n`DiscoLog` starts it automatically, unless you use [advanced configuration](guides/advanced-configuration.md)","ref":"DiscoLog.Supervisor.html"},{"type":"function","title":"DiscoLog.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DiscoLog.Supervisor.html#child_spec/1"},{"type":"function","title":"DiscoLog.Supervisor.maybe_presence/1","doc":"","ref":"DiscoLog.Supervisor.html#maybe_presence/1"},{"type":"function","title":"DiscoLog.Supervisor.start_link/1","doc":"","ref":"DiscoLog.Supervisor.html#start_link/1"},{"type":"task","title":"mix disco_log.cleanup","doc":"Delete all threads and messages from channels.","ref":"Mix.Tasks.DiscoLog.Cleanup.html"},{"type":"task","title":"mix disco_log.create","doc":"Creates the necessary discord channels for DiscoLog.","ref":"Mix.Tasks.DiscoLog.Create.html"},{"type":"task","title":"mix disco_log.drop","doc":"Delete the discord channels used by DiscoLog if they exist.","ref":"Mix.Tasks.DiscoLog.Drop.html"},{"type":"task","title":"mix disco_log.sample","doc":"Creates some sample logs and errors.","ref":"Mix.Tasks.DiscoLog.Sample.html"},{"type":"extras","title":"Getting Started","doc":"# Getting Started\n\nThis guide is an introduction to DiscoLog. It will guide you through the setup of DiscoLog and how to use it.","ref":"getting-started.html"},{"type":"extras","title":"Install DiscoLog - Getting Started","doc":"The first step is to add DiscoLog to your applicaiton is to declare the package as a dependency in your `mix.exs` file.\n\n```elixir\ndefp deps do\n  [\n    {:disco_log, \"~> 0.7.0\"}\n  ]\nend\n```\n\nThen run the following command to fetch the dependencies.\n\n```bash\nmix deps.get\n```","ref":"getting-started.html#install-discolog"},{"type":"extras","title":"Setup the Discord Server - Getting Started","doc":"You need to register a [Discord Account](https://discord.com/)","ref":"getting-started.html#setup-the-discord-server"},{"type":"extras","title":"Create a community Discord Server - Getting Started","doc":"*A Discord community server needs to have a forum-type channel, which we use for error tracking.*","ref":"getting-started.html#create-a-community-discord-server"},{"type":"extras","title":"Edit the Discord Server settings - Getting Started","doc":"*Right-click on the server and select `Server Settings` > `Community Settings`*\n \n \n \n \n \n\n*Copy the server ID, it will be needed later*\n\n+*If you don't see `Copy Server ID` in the UI, enable developer mode in Settings -> Advanced -> Developer Mode.*","ref":"getting-started.html#edit-the-discord-server-settings"},{"type":"extras","title":"Create a Discord Bot - Getting Started","doc":"Go to the [developers portal](https://discord.com/developers/applications)\n\n \n \n\n*Disable User Install and add the scope `bot` and the permissions `Attach Files`, `Manage Channels`, `Manage Threads`, `Send Messages`, `Send Messages in Threads`*\n \n\n*Generate and copy the bot token, it will be needed later*","ref":"getting-started.html#create-a-discord-bot"},{"type":"extras","title":"Add Bot to your Server - Getting Started","doc":"*Go to the installation menu and open the installation link*\n \n*Follow the steps*","ref":"getting-started.html#add-bot-to-your-server"},{"type":"extras","title":"Create DiscoLog channels - Getting Started","doc":"Edit your `config/dev.exs` and add the following configuration with the bot token and the server ID you copied earlier.\n\n```elixir\nconfig :disco_log,\n  otp_app: :app_name,\n  token: \"YOUR_BOT.TOKEN\",\n  guild_id: \"YOUR_SERVER_ID\"\n```\n\nRun the mix task\n```elixir\nmix disco_log.create\n```\n\nIt will create and output the rest of the necessary configuration for you.\nUse this configuration for your production environment or add it to your dev config if you want to test.\n\nConfirm that everything is working smoothly by running the following mix command it will put a log in each channels.\n```elixir\nmix disco_log.sample\n```\n\n*How it should look like*","ref":"getting-started.html#create-discolog-channels"},{"type":"extras","title":"After setup - Getting Started","doc":"When you confirmed that the setup is working you should put this config to disable DiscoLog in `dev.exs` and `test.exs` env.\n\n```elixir\nconfig :disco_log,\n  enable: false\n```","ref":"getting-started.html#after-setup"},{"type":"extras","title":"Presence Status - Getting Started","doc":"DiscoLog can optionally set your bot's status to **Online**, allowing you to display a custom presence message.","ref":"getting-started.html#presence-status"},{"type":"extras","title":"Steps to Enable Presence Status - Getting Started","doc":"1. **Add the `mint_web_socket` Package**  \n   Update your dependencies in `mix.exs`:\n\n   ```elixir\n   defp deps do\n     [\n       {:disco_log, \"~> 0.7.0\"},\n       {:mint_web_socket, \"~> 1.0\"}\n     ]\n   end\n   ```\n\n2. **Configure the Presence Settings**  \n   Add the following to your `config.exs` or `prod/config.exs`:\n\n   ```elixir\n   config :disco_log,\n     enable_presence: true,\n     presence_status: \"🪩 Disco Logging\" # Optional, defaults to this value\n   ```\n\n*Bot with Presence*","ref":"getting-started.html#steps-to-enable-presence-status"},{"type":"extras","title":"Go to Repo Feature - Getting Started","doc":"The **Go to Repo** feature allows DiscoLog to link directly to your code repository (e.g., GitHub). This enables users to easily access the specific version of the code related to a log entry.","ref":"getting-started.html#go-to-repo-feature"},{"type":"extras","title":"Example Interface - Getting Started","doc":"*Link to GitHub code*","ref":"getting-started.html#example-interface"},{"type":"extras","title":"Configuration Instructions - Getting Started","doc":"To enable this feature, add the following configuration to your `prod/config.exs`:\n\n```elixir\nconfig :disco_log,\n  enable_go_to_repo: true,\n  go_to_repo_top_modules: [\"DemoWeb\"], # Optional, see notes below\n  repo_url: \"https://github.com/mrdotb/disco-log/blob\",\n  git_sha: System.fetch_env!(\"GIT_SHA\") # See notes on setting the GIT_SHA below\n```","ref":"getting-started.html#configuration-instructions"},{"type":"extras","title":"Setting the `GIT_SHA` - Getting Started","doc":"The `GIT_SHA` should be the commit hash of the current code version. This ensures links reference the correct version of the code. Here’s how you can set it, depending on your deployment process:\n\n#### 1. **Bare Metal Deployments**\nIf you build your release on your own machine, you can set the environment variable using this command:\n\n```bash\nGIT_SHA=`git rev-parse HEAD` MIX_ENV=prod mix release\n```\n\n#### 2. **Docker Deployments**\nWhen building a Docker image, pass the `GIT_SHA` as a build argument:\n\n**Build Command**:\n```bash\ndocker build --build-arg GIT_SHA=`git rev-parse HEAD` .\n```\n\n**Dockerfile**:\n```Dockerfile\nARG GIT_SHA\n\n# Set build environment variables\nENV MIX_ENV=\"prod\"\nENV GIT_SHA=${GIT_SHA}\n```\n\n#### 3. **CI/CD Pipelines**\nIn CI/CD environments (e.g., GitHub Actions), the `GIT_SHA` is often available as a predefined environment variable. You can pass it during the build process as follows:\n\n**Example GitHub Actions Workflow**:\n```yaml\n- name: Build and Push Docker Image to GHCR\n  uses: docker/build-push-action@v5\n  with:\n    context: .\n    push: true\n    tags: ${{ steps.meta.outputs.tags }}\n    labels: ${{ steps.meta.outputs.labels }}\n    build-args: |\n      BUILD_METADATA=${{ steps.meta.outputs.json }}\n      ERL_FLAGS=+JPperf true\n      GIT_SHA=${{ github.sha }}\n```","ref":"getting-started.html#setting-the-git_sha"},{"type":"extras","title":"Notes - Getting Started","doc":"- The `repo_url` configuration should point to the root of your repository's code (e.g., `https://github.com/ / /blob`).\n- The `go_to_repo_top_modules` configuration is optional. Use it only if your project contains external modules within the repository.\n\nEnjoy using DiscoLog!","ref":"getting-started.html#notes"},{"type":"extras","title":"Advanced Configuration","doc":"# Advanced Configuration\n\nBy default, `DiscoLog` runs a supervisor with all necessary processes under its\nown application. However, you can run everything manually in case you want to log\nto multiple servers, take advantage of logger filters and other features, or\nsimply have better control over how logging is run within your application.\n\n> #### Mix Tasks {: .warning}\n>\n> Mix tasks that come with `DiscoLog` always read from the default configuration \nand won't work with advanced setup.\n\nFirst, disable the `DiscoLog` default application in your `config/config.exs`:\n\n```elixir\nconfig :disco_log, enable: false\n```\n\nThen, define the `DiscoLog` configuration the way you want it. For example, in\nthe config under your application's key. Let's say you want to log to not one\nbut 2 Discord servers at once:\n\n```elixir\nconfig :my_app, DiscoLog,\n  shared: [\n    otp_app: :my_app,\n    metadata: [:extra]\n  ],\n  server_a: [\n    guild_id: \"1234567891011121314\",\n    token: \"server_A_secret_token\"\n    category_id: \"1234567891011121314\",\n    occurrences_channel_id: \"1234567891011121314\",\n    info_channel_id: \"1234567891011121314\",\n    error_channel_id: \"1234567891011121314\",\n    supervisor_name: MyApp.DiscoLog.ServerA\n  ],\n  server_b: [\n    guild_id: \"9876543210123456789\",\n    token: \"server_B_secret_token\"\n    category_id: \"9876543210123456789\",\n    occurrences_channel_id: \"9876543210123456789\",\n    info_channel_id: \"9876543210123456789\",\n    error_channel_id: \"9876543210123456789\",\n    supervisor_name: MyApp.DiscoLog.ServerB\n  ]\n```\n\nFinally, at startup, you'll need to start as many `DiscoLog.Supervisor` as you\nneed and attach the logger handlers. They share the same configuration, which\nyou can validate with `DiscoLog.Config.validate!/1`. Note the `supervisor_name`\nconfiguration option. This is what tells the logger handler which supervisor\nprocess it should use.\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    [\n      shared: shared,\n      server_a: config_a,\n      server_b: config_b\n    ] = Application.fetch_env!(:my_app, DiscoLog)\n\n    config_a = DiscoLog.Config.validate!(shared ++ config_a)\n    config_b = DiscoLog.Config.validate!(shared ++ config_b)\n    \n    :logger.add_handler(:disco_server_a, DiscoLog.LoggerHandler, %{config: config_a})\n    :logger.add_handler(:disco_server_b, DiscoLog.LoggerHandler, %{config: config_b})\n\n    children = [\n      {DiscoLog.Supervisor, config_a},\n      {DiscoLog.Supervisor, config_b},\n    ]\n\n    Supervisor.start_link(children, strategy: :one_for_one)\n  end\n```\n\nThat's it! From here, you can build upon a highly flexible Elixir logging stack\nwith `DiscoLog`!","ref":"advanced-configuration.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}